FEENABLEEXCEPT(3)

NAME
feenableexcept, fedisableexcept, fegetexcept - floating-point exception masking

LIBRARY
libm

SYNOPSIS
#include <fenv.h>
#pragma STDC FENV_ACCESS ON
int
feenableexcept(int excepts);
int
fedisableexcept(int excepts);
int
fegetexcept(void);

DESCRIPTION
The feenableexcept() and fedisableexcept() functions unmask and mask (respectively) exceptions specified in excepts. The fegetexcept() function returns the current exception mask. All exceptions are masked by default.

Floating-point operations that produce unmasked exceptions will trap, and a SIGFPE will be delivered to the process. By installing a signal handler for SIGFPE, applications can take appropriate action immediately without testing the exception flags after every operation. Note that the trap may not be immediate, but it should occur before the next floating-point instruction is executed.

For all of these functions, the possible types of exceptions include those described in fenv(3). Some architectures may define other types of floating-point exceptions.

RETURN VALUES
The feenableexcept(), fedisableexcept(), and fegetexcept() functions return a bitmap of the exceptions that were unmasked prior to the call.

SEE ALSO
sigaction(2), feclearexcept(3), feholdexcept(3), fenv(3), feupdateenv(3)

BUGS
Functions in the standard library may trigger exceptions multiple times as a result of intermediate computations; however, they generally do not trigger spurious exceptions.

No interface is provided to permit exceptions to be handled in nontrivial ways. There is no uniform way for an exception handler to access information about the exception-causing instruction, or to determine whether that instruction should be reexecuted after returning from the handler.